from numpy import exp, sin, pi, linspace
from matplotlib import pyplot as plt

x = linspace(0,5,400)       # Generate 400 evenly spaced points on [0,5]
y = exp(0.5 - sin(5*pi*x))  # Compute y

##
# Plot
plt.plot(x,y,'-k')
plt.title('Sample Plot', fontsize='large')
plt.tick_params(labelsize='large')
plt.xlabel(r'$x$', fontsize='large')
plt.ylabel(r'$y$', fontsize='large')
plt.legend(['$y = e^{1/2 - \sin (5\pi x)}$'], fontsize='large')
#plt.show()
plt.savefig('sample.png', dpi=500, format='png', bbox_inches='tight', pad_inches=0.0,)


