from numpy import *
from matplotlib import pyplot
import matplotlib.animation as manimation
import os, sys

# HW5 Skeleton 

def RK4(f, y, t, dt, food_flag, alpha, gamma_1, gamma_2, kappa, rho, delta):
    '''
    Carry out a step of RK4 from time t using dt
    
    Input
    -----
    f:  Right hand side value function (this is the RHS function)
    y:  state vector
    t:  current time
    dt: time step size
    
    food_flag:  0 or 1, depending on the food location
    alpha:      Parameter from homework PDF
    gamma_1:    Parameter from homework PDF
    gamma_2:    Parameter from homework PDF
    kappa:      Parameter from homework PDF
    rho:        Parameter from homework PDF
    delta:      Parameter from homework PDF
    

    Output
    ------
    Return updated vector y, according to RK4 formula
    '''
    
    # Task: Fill in the RK4 formula
    k1 = f(...)
    k2 = f(...)
    k3 = f(...)
    k4 = f(...)

    return ... 


def RHS(y, t, food_flag, alpha, gamma_1, gamma_2, kappa, rho, delta):
    '''
    Define the right hand side of the ODE

    '''
    N = y.shape[0]
    f = zeros_like(y)
    
    # Task:  Fill this in by assigning values to f
    
    return f


##
# Set up problem domain
t0 = 0.0        # start time
T = 10.0        # end time
nsteps = 75     # number of time steps

# Task:  Experiment with N, number of birds
N = 30

# Task:  Experiment with the problem parameters, and understand how each parameter affects the system
dt = (T - t0) / (nsteps-1.0)
gamma_1 = 2.0
gamma_2 = 8.0
alpha = 0.4
kappa = 4.0
rho = 2.0
delta = 0.5
food_flag = 1   # food_flag == 0: C(x,y) = (0.0, 0.0)
                # food_flag == 1: C(x,y) = (sin(alpha*t), cos(alpha*t))

# Intialize problem
y = random.rand(N,2)  # This is the state vector of each Bird's position.  The k-th bird's position is (y[k,0], y[k,1])
flock_diam = zeros((nsteps,))

# Write first movie frame
# - File name format: flock_frame_k.png  for k = 0, 1, ...
# - Note that the figure size is set so that there are an even number of pixels
#   in each dimension.  This can be important for converting to movie later 
pyplot.figure(figsize=(5.75, 4.5), dpi=152)
pyplot.plot(y[1:,0], y[1:,1], 'k+') 
pyplot.plot(y[0,0], y[0,1], 'r+') 
pyplot.xlabel(r'$X$', fontsize='large')
pyplot.ylabel(r'$Y$', fontsize='large')
pyplot.xlim(-3,3)       # you may need to adjust this, if your birds fly outside of this box!
pyplot.ylim(-3,3)       # you may need to adjust this, if your birds fly outside of this box!
pyplot.savefig('flock_frame_0.png', pad_inches=0.12, bbox_inches='tight', dpi=150)
pyplot.close()


# Take nsteps time-steps, and write rest of movie frames
t = t0
for step in range(nsteps):
    
    # Task: Fill in the code for the next three lines 
    y = RK4(...) 
    flock_diam[step] = ... 
    t += ...
    
    # Task: Write the new movie frame to file
    filename = "flock_frame_%d.png"%step
    pyplot....


# Task: Plot flock diameter
plot(..., flock_diam, ...)


# Task: Create movie
# - Set this if-statement to True to generate movie
#
# Also..
# - This code is already done for you, but you may need to play around with 
#   the codec commands for your system
# - You will need to install moviepy and ffmpeg (see HW PDF) 
if False:
    import moviepy.video.io.ImageSequenceClip
    fps=6
    image_files = [ "flock_frame_%d.png"%k for k in range(nsteps) ]
    clip = moviepy.video.io.ImageSequenceClip.ImageSequenceClip(image_files, fps=fps)
    
    # Codecs can be tricky. If your video is "hard" to open, you can try the commented out commands
    clip.write_videofile('flock_movie.mp4') 
    #clip.write_videofile('flock_movie.mp4', codec='libx264')
    #clip.write_videofile('flock_movie.mp4', codec='mpeg4')
    #clip.write_videofile('flock_movie.mp4', codec='libx264', ffmpeg_params=["-pix_fmt", "yuv420p"])
    #clip.write_videofile('flock_movie.mp4', codec='mpeg4', ffmpeg_params=["-pix_fmt", "yuv420p"])



