from numpy import *
from matplotlib import pyplot

##
# Homework 5 Preliminary
# Practice implementing Euler, RK2, and RK4
##

def euler(f, y0, n, t0, T):
    '''
    Carry out Euler's method on [t0, T]
    for y' = f(t,y), nsteps n, and initial 
    condition y0.
    '''

    y = zeros((n,))
    y[0] = y0
    h = # Task: insert formula for step-size h

    for i in range(1, n):
        # Task: insert formula for Euler's method
        y[i] = ... 

    return y

def RK2(f, y0, n, t0, T):
    '''
    Carry out RK2 on [t0, T]
    for y' = f(t,y), nsteps n, and initial 
    condition y0.
    '''

    y = zeros((n,))
    y[0] = y0
    h = # Task: insert formula for step-size h

    for i in range(1, n):
        # Task: insert formula for RK2 
        k1 = ... 
        k2 = ... 
        y[i] = ... 

    return y

def RK4(f, y0, n, t0, T):
    '''
    Carry out RK4 on [t0, T]
    for y' = f(t,y), nsteps n, and initial 
    condition y0.
    '''

    y = zeros((n,))
    y[0] = y0
    h = # Task: insert formula for step-size h

    for i in range(1, n):
        
        # Task: insert formula for RK4 
        k1 = ... 
        k2 = ... 
        k3 = ... 
        k4 = ... 

        y[i] = ... 

    return y


##
# Define your forcing function f(t,y) and your exact solution for checking error
##

def f(t, y):
    # y'(t) = f(t, y)
    # f(t,y) = t*y + t**3
    return # Task: insert return statement for f(t,y)

def yexact(t):
    # solution y(t) = 3 exp( (t**2) / 2) - t**2 - 2.0
    return # Task: insert exact solution 


##
# Set up your problem domain
##

t0 = 0.0        # initial time
T = 1.0         # final time
y0 = 1.0        # initial value at yexact(0)
n = 5           # Number of steps for your first ODE experiments

##
# Carry out your first numerical ODE experiments, solve the above problem from
# time t0 until time T, using n=5 time-steps.
yE = euler( #Task: insert call to euler 
yRK2 = RK2( #Task: insert call to RK2
yRK4 = RK4( #Task: insert call to RK4

##
# Plotting the results for the above experiment.  
# The plotting is taken care of for you, don't need to change anything
##
pyplot.figure(1)
pts = linspace(t0, T, n)
manypts = linspace(t0, T, 2000)
pyplot.plot(pts, yE, linewidth='2') 
pyplot.plot(pts, yRK2, linewidth='4') 
pyplot.plot(pts, yRK4, linewidth='2') 
pyplot.plot(manypts, yexact(manypts), linewidth='2') 
pyplot.xlabel(r'$X$', fontsize='large')
pyplot.ylabel(r'$Y$', fontsize='large')
pyplot.legend(['Euler', 'RK2', 'RK4', 'Exact'], fontsize='large') 
pyplot.savefig('Compare_Solution_E_RK2_RK4.png', dpi=500, format='png', bbox_inches='tight', pad_inches=0.0,)


##
# Next, we do a convergence study for 10 different problem sizes
##

# Initialize 3 arrays to store your error for each of the 10 problem sizes, and
# each of the 3 methods
EulerError = zeros((10,))
RK2Error = zeros((10,))
RK4Error = zeros((10,))

# These are the problem sizes that we will loop over
ns = 10*arange(1,100,10)

# Begin loop over the problem sizes
for i,n in enumerate(ns):
    
    h = # Task: Compute the time step size h for n steps on the domain [t0, T]
    yE = euler( #Task: insert call to euler using n steps
    yRK2 = RK2( #Task: insert call to RK2 using n steps
    yRK4 = RK4( #Task: insert call to RK4 using n steps
    yExact = yexact( #Task: insert call to yexact 

    EulerError[i] = # Task: insert L2-norm of the error yE - yExact
    RK2Error[i] = # Task: insert L2-norm of the error yRK2 - yExact
    RK4Error[i] = # Task: insert L2-norm of the error yRK4 - yExact
    

# Task: Make sure you understand how the loop iterates over 10 problem sizes.  
#       Add a new problem size (an 11th size) that is larger than the current 10th size

##
# Plot the error for Euler, RK2 and RK4 
##
pyplot.figure(2)
pyplot.loglog(1.0/ns, EulerError, 'k') 
pyplot.loglog(1.0/ns, RK2Error, 'r') 
pyplot.loglog(1.0/ns, RK4Error, 'm') 

# Task: insert reference curves for linear, quadratic, and quartic convergence 
pyplot.loglog( #Task: Insert reference linear curve relative to ns
pyplot.loglog( #Task: Insert reference quadratic curve relative to ns
pyplot.loglog( #Task: Insert reference quartic curve relative to ns

pyplot.xlabel(r'$h$', fontsize='large')
pyplot.ylabel('Error', fontsize='large')
pyplot.legend(['Euler', 'RK2', 'RK4', r'$h$', r'$h^2$', r'$h^4$'], fontsize='large') 
pyplot.savefig('Compare_error_E_RK2_RK4.png', dpi=500, format='png', bbox_inches='tight', pad_inches=0.0,)

