from mpi4py import MPI

#
# Sample MPI to run with ONLY 2 processors, 
#  $ mpirun -np 2 python3 minimal_mpi.py
#
# Task: Read through this file, run it, and make sure that 
#       understand the output.
#
# Task: Change data in line 22 to be a vector of all ones.  
#       Predict how that will change the program's output

# For some implementations, you may need to do this
#MPI.Init()

comm = MPI.COMM_WORLD
rank = comm.Get_rank()
nprocs = comm.size

print("My rank is %d out of %d total processors"%(rank,nprocs))

import numpy
# passing MPI datatypes explicitly
if rank == 0:
    data = numpy.arange(10, dtype='i')
    print("\nRank ", rank, "  Before array: ", data)
    comm.Send([data, MPI.INT], dest=1, tag=77)
    print("\nRank ", rank, "  After, array: ", data)
elif rank == 1:
    data = numpy.empty(10, dtype='i')
    print("\nRank ", rank, "  Before array: ", data)
    comm.Recv([data, MPI.INT], source=0, tag=77)
    print("\nRank ", rank, "  After, array: ", data)

MPI.Finalize()

